package tools.mdsd.ecoreworkflow.mwe2lib.xtext.config;

import com.google.common.base.Objects;
import org.eclipse.xtend.lib.annotations.Accessors;
import org.eclipse.xtext.xbase.lib.Pure;
import org.eclipse.xtext.xtext.generator.model.project.BundleProjectConfig;
import org.eclipse.xtext.xtext.generator.model.project.RuntimeProjectConfig;
import org.eclipse.xtext.xtext.generator.model.project.StandardProjectConfig;
import org.eclipse.xtext.xtext.generator.model.project.SubProjectConfig;
import org.eclipse.xtext.xtext.generator.model.project.WebProjectConfig;

@Accessors
@SuppressWarnings("all")
public class TychoStandardLayoutProjectConfig extends StandardProjectConfig {
  private String bundlesFolder = "bundles";
  
  private String featuresFolder = "features";
  
  private String testsFolder = "tests";
  
  private String relengFolder = "releng";
  
  @Override
  protected String computeRoot(final SubProjectConfig project) {
    String _xblockexpression = null;
    {
      String _switchResult = null;
      boolean _matched = false;
      RuntimeProjectConfig _runtime = this.getRuntime();
      if (Objects.equal(project, _runtime)) {
        _matched=true;
        _switchResult = this.bundlesFolder;
      }
      if (!_matched) {
        BundleProjectConfig _runtimeTest = this.getRuntimeTest();
        if (Objects.equal(project, _runtimeTest)) {
          _matched=true;
          _switchResult = this.testsFolder;
        }
      }
      if (!_matched) {
        BundleProjectConfig _genericIde = this.getGenericIde();
        if (Objects.equal(project, _genericIde)) {
          _matched=true;
          _switchResult = this.bundlesFolder;
        }
      }
      if (!_matched) {
        BundleProjectConfig _eclipsePlugin = this.getEclipsePlugin();
        if (Objects.equal(project, _eclipsePlugin)) {
          _matched=true;
          _switchResult = this.bundlesFolder;
        }
      }
      if (!_matched) {
        BundleProjectConfig _eclipsePluginTest = this.getEclipsePluginTest();
        if (Objects.equal(project, _eclipsePluginTest)) {
          _matched=true;
          _switchResult = this.testsFolder;
        }
      }
      if (!_matched) {
        WebProjectConfig _web = this.getWeb();
        if (Objects.equal(project, _web)) {
          _matched=true;
          _switchResult = this.bundlesFolder;
        }
      }
      final String folderPrefix = _switchResult;
      String _rootPath = this.getRootPath();
      String _plus = (_rootPath + "/");
      String _plus_1 = (_plus + folderPrefix);
      String _plus_2 = (_plus_1 + "/");
      String _name = project.getName();
      _xblockexpression = (_plus_2 + _name);
    }
    return _xblockexpression;
  }
  
  @Pure
  public String getBundlesFolder() {
    return this.bundlesFolder;
  }
  
  public void setBundlesFolder(final String bundlesFolder) {
    this.bundlesFolder = bundlesFolder;
  }
  
  @Pure
  public String getFeaturesFolder() {
    return this.featuresFolder;
  }
  
  public void setFeaturesFolder(final String featuresFolder) {
    this.featuresFolder = featuresFolder;
  }
  
  @Pure
  public String getTestsFolder() {
    return this.testsFolder;
  }
  
  public void setTestsFolder(final String testsFolder) {
    this.testsFolder = testsFolder;
  }
  
  @Pure
  public String getRelengFolder() {
    return this.relengFolder;
  }
  
  public void setRelengFolder(final String relengFolder) {
    this.relengFolder = relengFolder;
  }
}
